rpm: RPM IO API.

rpm 4.16.1.3

Files | Typedefs
RPM IO API.
I/O

The RPM IO API (Fd_t is RPM equivalent to libc's FILE). More...

Collaboration diagram for RPM IO API.:

## Files
file | rpmio.h
| RPM I/O API (Fd_t is RPM equivalent to libc's FILE)
file | rpmurl.h
| A couple utils for URL Manipulation.
file | rpmmacro.h
| Macro API.
file | rpmlog.h
| Yet Another syslog(3) API clone.
file | rpmsq.h
| Signal Queue API.
file | rpmsw.h
| Statistics API.
file | rpmfileutil.h
| File and path manipulation helper functions.
file | rpmbase64.h
| Base64 encoding and decoding API.

## Typedefs
typedef const struct FDIO_s * | FDIO_t

## RPMIO Interface.
const char * | Fstrerror (FD_t fd)
| strerror(3) clone. More...
ssize_t | Fread (void *buf, size_t size, size_t nmemb, FD_t fd)
| Like fread(3) but with read(3)-style return values. More...
ssize_t | Fwrite (const void *buf, size_t size, size_t nmemb, FD_t fd)
| Like fwrite(3) but with write(3)-style return values. More...
int | Fseek (FD_t fd, off_t offset, int whence)
| fseek(3) clone. More...
off_t | Ftell (FD_t fd)
| ftell(3) clone. More...
int | Fclose (FD_t fd)
| fclose(3) clone. More...
FD_t | Fdopen (FD_t ofd, const char *fmode)
FD_t | Fopen (const char *path, const char *fmode)
| fopen(3) clone. More...
int | Fflush (FD_t fd)
| fflush(3) clone. More...
int | Ferror (FD_t fd)
| ferror(3) clone. More...
int | Fileno (FD_t fd)
| fileno(3) clone. More...
int | Fcntl (FD_t fd, int op, void *lip)
| fcntl(2) clone. More...
const char * | Fdescr (FD_t fd)
| Get informative description (eg file name) from fd for diagnostic output. More...

## RPMIO Utilities.
enum | fdOpX_e { FDSTAT_READ = 0, FDSTAT_WRITE = 1, FDSTAT_SEEK = 2, FDSTAT_CLOSE = 3, FDSTAT_DIGEST = 4, FDSTAT_MAX = 5 }
| Identify per-desciptor I/O operation statistics. More...
typedef enum fdOpX_e | fdOpX
| Identify per-desciptor I/O operation statistics. More...
off_t | fdSize (FD_t fd)
FD_t | fdDup (int fdno)
FD_t | fdLink (FD_t fd)
FD_t | fdFree (FD_t fd)
rpmop | fdOp (FD_t fd, fdOpX opx)
off_t | ufdCopy (FD_t sfd, FD_t tfd)

## Detailed Description

The RPM IO API (Fd_t is RPM equivalent to libc's FILE).

## Typedef Documentation

## ◆ FDIO_t

typedef const struct FDIO_s* FDIO_t

Definition at line 25 of file rpmio.h.

## ◆ fdOpX

typedef enum fdOpX_e fdOpX

Identify per-desciptor I/O operation statistics.

## Enumeration Type Documentation

## ◆ fdOpX_e

enum fdOpX_e

Identify per-desciptor I/O operation statistics.

Enumerator
FDSTAT_READ | Read statistics index.
FDSTAT_WRITE | Write statistics index.
FDSTAT_SEEK | Seek statistics index.
FDSTAT_CLOSE | Close statistics index
FDSTAT_DIGEST | Digest statistics index.
FDSTAT_MAX |

Definition at line 125 of file rpmio.h.

## Function Documentation

## ◆ Fclose()

int Fclose | ( | FD_t | fd | ) |

fclose(3) clone.

## ◆ Fcntl()

int Fcntl | ( | FD_t | fd,
|  | int | op,
|  | void * | lip
| ) |  |

fcntl(2) clone.

## ◆ fdDup()

FD_t fdDup | ( | int | fdno | ) |

## ◆ Fdescr()

const char* Fdescr | ( | FD_t | fd | ) |

Get informative description (eg file name) from fd for diagnostic output.

## ◆ fdFree()

FD_t fdFree | ( | FD_t | fd | ) |

## ◆ fdLink()

FD_t fdLink | ( | FD_t | fd | ) |

## ◆ fdOp()

rpmop fdOp | ( | FD_t | fd,
|  | fdOpX | opx
| ) |  |

## ◆ Fdopen()

FD_t Fdopen | ( | FD_t | ofd,
|  | const char * | fmode
| ) |  |

## ◆ fdSize()

off_t fdSize | ( | FD_t | fd | ) |

## ◆ Ferror()

int Ferror | ( | FD_t | fd | ) |

ferror(3) clone.

## ◆ Fflush()

int Fflush | ( | FD_t | fd | ) |

fflush(3) clone.

## ◆ Fileno()

int Fileno | ( | FD_t | fd | ) |

fileno(3) clone.

## ◆ Fopen()

FD_t Fopen | ( | const char * | path,
|  | const char * | fmode
| ) |  |

fopen(3) clone.

## ◆ Fread()

ssize_t Fread | ( | void * | buf,
|  | size_t | size,
|  | size_t | nmemb,
|  | FD_t | fd
| ) |  |

Like fread(3) but with read(3)-style return values.

## ◆ Fseek()

int Fseek | ( | FD_t | fd,
|  | off_t | offset,
|  | int | whence
| ) |  |

fseek(3) clone.

## ◆ Fstrerror()

const char* Fstrerror | ( | FD_t | fd | ) |

strerror(3) clone.

## ◆ Ftell()

off_t Ftell | ( | FD_t | fd | ) |

ftell(3) clone.

## ◆ Fwrite()

ssize_t Fwrite | ( | const void * | buf,
|  | size_t | size,
|  | size_t | nmemb,
|  | FD_t | fd
| ) |  |

Like fwrite(3) but with write(3)-style return values.

## ◆ ufdCopy()

off_t ufdCopy | ( | FD_t | sfd,
|  | FD_t | tfd
| ) |  |